Part Module

From FreeCAD Documentation
Revision as of 10:26, 26 April 2009 by Wmayer (talk | contribs) (Boolean Operations)
Jump to: navigation, search

Introduction

the CAD capabilities of FreeCAD are based on the OpenCasCade kernel. The Part module allows FreeCAD to access and use the OpenCasCade objects and functions. OpenCascade is a professional-level CAD kernel, that features advanced 3D geometry manipulation and objects. The Part objects, unlike Mesh Module objects, are much more complex, and therefore permit much more advanced operations, like coheent booleans operations, modifications history and parametric behaviour.

Part example.jpg

Example of Part shapes in FreeCAD

In OpenCasCade terminology, we distinguish between geometric primitives and (topological) shapes. A geometric primitive can be a point, a line, a circle, a plane, etc. or even some more complex types like a B-Spline curve or surface. A shape can be a vertex, an edge, a wire, a face, a solid or a compound of other shapes. The geometric primitive are not made to be directly displayed on the 3D scene, but rather to be used as building geometry for shapes. For example, an edge can be constructed from a line or from a portion of a circle.

We could say, to resume, that geometry primitive are the building blocks, and shapes are what appears on screen.

To get a complete list of all of them refer to the OCC documentation and search for Geom_Geometry and TopoDS_Shape. There you can also read more about the differences between geometric objects and shapes. Please note that unfortunately the OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counter part.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shape a more complex shape is made of.

Using the Part module

The Part module tools are all located in the Part menu that appears when you load the Part module. At the moment, you can:

  • Create primitive geometry like Plane, Box, Cylinder, Cone, Sphere, Ellipsoid and Torus
  • Import shapes from other file formats
  • Make boolean operations (union, subtraction, intersection) on shapes
  • Extrude flat shapes
  • Fillet edges of shapes

To create primitives from the user interface switch to the Part design workbench and click on 'Create primitives...' menu item under the Part menu. This opens a dialog where you are able to define the type of primitive and further properties depending on the type you have chosen. Then click on the 'Create' button to create such an element. At the moment available primitives are Plane, Box, Cylinder, Cone, Sphere, Ellipsoid and Torus.

The Part module is at the moment intended primarily to make its objects available to other parts of FreeCAD, so it has very few user interface elements on its own. But the Part module is under heavy extension work at the moment, so you can expect to find much more in it than described here.

Boolean Operations

An example of union, intersection and difference

Scripting

The main data structure used in the Part module is the BRep data type from OpenCascade. About all contents and object types of the Part module are now available to python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creations methods exist, and for some of them, especially the TopoShapes, advanced operations like booleans union/difference/intersection are also available. Explore the contents of the Part module, as described in the FreeCAD Scripting Basics page, to know more.

Examples

To create a line element switch to the Python console and type in:

import Part,PartGui 
doc=App.newDocument()  
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Let's go through the above python example step by step:

import Part,PartGui
doc=App.newDocument()

loads the Part module and creates a new document

l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line is actually a line segment, hence the start and endpoint.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.line) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

doc.recompute()

Updates the document. This also prepare the visual representation of the new part object.

Note that a Line can be created by specifiying its start and endpoint directly in the constructor, for ex. Part.Line(point1,point2) or we can create a default line and set its properties afterwards, like we did here.

A circle can be created in a similar way:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Here we take the shape of our object f, then we take its list of edges, in this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

Head to the Topological data scripting page if you would like to know more.